<?php
/*---------------------------------------------------------------*/
/* Register shortcode within Visual Composer interface
/*---------------------------------------------------------------*/

add_action( 'init', 'extend_VC_map' );
function extend_VC_map() {

	$add_css_animation = array(
		'type' => 'dropdown',
		'heading' => __( 'CSS Animation', 'js_composer' ),
		'param_name' => 'css_animation',
		'admin_label' => true,
		'value' => array(
			__( 'No', 'js_composer' ) => '',
			__( 'Top to bottom', 'js_composer' ) => 'top-to-bottom',
			__( 'Bottom to top', 'js_composer' ) => 'bottom-to-top',
			__( 'Left to right', 'js_composer' ) => 'left-to-right',
			__( 'Right to left', 'js_composer' ) => 'right-to-left',
			__( 'Appear from center', 'js_composer' ) => "appear"
		),
		'description' => __( 'Select type of animation if you want this element to be animated when it enters into the browsers viewport. Note: Works only in modern browsers.', 'js_composer' )
	);

	$add_css_animation_delay = array(
		"type" => "dropdown",
		"heading" => __("CSS Animation Delay", "js_composer"),
		"param_name" => "css_animation_delay",
		"value" => array(
			'0ms' => '', 
			'100ms' => 'delay-100', 
			'200ms' => 'delay-200', 
			'300ms' => 'delay-300', 
			'400ms' => 'delay-400', 
			'500ms' => 'delay-500', 
			'600ms' => 'delay-600', 
			'700ms' => 'delay-700', 
			'800ms' => 'delay-800', 
			'900ms' => 'delay-900', 
			'1000ms' => 'delay-1000', 
			'1100ms' => 'delay-1100', 
			'1200ms' => 'delay-1200', 
			'1300ms' => 'delay-1300', 
			'1400ms' => 'delay-1400', 
			'1500ms' => 'delay-1500', 
			'1600ms' => 'delay-1600',
			'1700ms' => 'delay-1700',
			'1800ms' => 'delay-1800', 
			'1900ms' => 'delay-1900', 
			'2000ms' => 'delay-2000'
		),
		"dependency" => Array('element' => "css_animation", 'not_empty' => true)
	);

	  
	// Row
	vc_map( array(
		"name" => __("Row", "js_composer"),
		"base" => "vc_row",
		"is_container" => true,
		"icon" => "icon-wpb-row",
		"show_settings_on_create" => false,
		"category" => __('Content', 'js_composer'),
		"admin_enqueue_css" => array( MNKY_PLUGIN_URL . 'assets/css/device-font.css'),
		"description" => __('Place content elements inside the row', 'js_composer'),
		"params" => array(		
			array(
				"type" => 'checkbox',
				"heading" => __("Full width content", "js_composer"),
				"param_name" => "full_content_width",
				"value" => Array(__("Yes, please", "js_composer") => 'row-inner-full'),
			),
			array(
				"type" => "colorpicker",
				"heading" => __("Background color", "js_composer"),
				"param_name" => "bg_color",
				"group" => __('Background', 'js_composer')
			),		
			array(
				"type" => "attach_image",
				"heading" => __("Background image", "js_composer"),
				"param_name" => "bg_image",
				"group" => __('Background', 'js_composer')
			),
			array(
				"type" => 'checkbox',
				"heading" => __("Full background cover", "js_composer"),
				"param_name" => "bg_cover",
				"description" => __("Scale the background image to be as large as possible so that the background area is completely covered by the background image. Some parts of the background image may not be in view within the background positioning area.", "js_composer"),
				"value" => Array(__("Enable", "js_composer") => 'cover'),
				"dependency" => Array('element' => "bg_image", 'not_empty' => true),
				"group" => __('Background', 'js_composer')
			),
			array(
				"type" => "dropdown",
				"heading" => __("Background repeat", "js_composer"),
				"param_name" => "bg_repeat",
				"value" => array('Repeat all' => '', 'Repeat horizontally' => 'repeat-x', 'Repeat vertically' => 'repeat-y', 'No repeat' => 'no-repeat'),
				"description" => __("The background-repeat property sets if/how a background image will be repeated.", "js_composer"),
				"dependency" => Array('element' => "bg_image", 'not_empty' => true),
				"group" => __('Background', 'js_composer')
			),		
			array(
				"type" => "dropdown",
				"heading" => __("Background position", "js_composer"),
				"param_name" => "bg_position",
				"value" => array('Left top' => '', 'Left center', 'Left bottom', 'Right top', 'Right center', 'Right bottom', 'Center top', 'Center center', 'Center bottom'),
				"description" => __("The background-position property sets the starting position of a background image.", "js_composer"),
				"dependency" => Array('element' => "bg_image", 'not_empty' => true),
				"group" => __('Background', 'js_composer')
			),
			array(
				"type" => "dropdown",
				"heading" => __("Background attachment", "js_composer"),
				"param_name" => "bg_attachment",
				"value" => array('Scroll' => '', 'Fixed' => 'fixed'),
				"description" => __("The background-attachment property sets whether a background image is fixed or scrolls with the rest of the page.", "js_composer"),
				"dependency" => Array('element' => "bg_image", 'not_empty' => true),
				"group" => __('Background', 'js_composer')
			),
			array(
				"type" => "dropdown",
				"heading" => __("Row seperator", "js_composer"),
				"param_name" => "row_seperator",
				"value" => array('None' => 'no-seperator', 'Solid line' => 'row-line-seperator', 'Shadow' => 'row-shadow-seperator'),
				"description" => __("Separator separates current row from content element above", "js_composer")
			),
			array(
				"type" => "colorpicker",
				"heading" => __('Font Color', 'wpb'),
				"param_name" => "font_color",
				"group" => __('Typography', 'js_composer'),
			),
			array(
				"type" => "dropdown",
				"heading" => __("Font weight", "js_composer"),
				"param_name" => "font_weight",
				"value" => array(__("Inherit", "js_composer") => "", __("Normal", "js_composer") => "normal", __("Lighter", "js_composer") => "lighter", __("Bold", "js_composer") => "bold", __("Bolder", "js_composer") => "bolder"),
				"group" => __('Typography', 'js_composer')
			),
			array(
				"type" => "dropdown",
				"heading" => __("Row text align", "js_composer"),
				"param_name" => "textalign",
				"value" => array(__("Inherit", "js_composer") => "", __("Left", "js_composer") => "left", __("Center", "js_composer") => "center", __("Right", "js_composer") => "right"),
				"group" => __('Typography', 'js_composer')
			),
			array(
				"type" => "textfield",
				"heading" => __("Padding top", "js_composer"),
				"param_name" => "top",
				"value" => '70px',
				"description" => __("The padding-top property sets the top padding (space) of an element.", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Padding bottom", "js_composer"),
				"param_name" => "bottom",
				"value" => '70px',
				"description" => __("The padding-badding property sets the bottom padding (space) of an element.", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Add ID to section", "js_composer"),
				"param_name" => "section_id",
				"group" => __('Section ID', 'js_composer'),
				"description" => __("This ID is used in Section Menu element. Please give unique ID to each row, when using section menu.", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			),
			array(
				"type" => 'checkbox',
				"heading" => __("Row columns", "js_composer"),
				"param_name" => "row_mobile_style",
				"description" => __("When enabled, all columns are made 100% wide and stacked above each other", "js_composer"),
				"value" => Array(__("Make this row content 100% width in Tablet Portrait (on screen sizes smaller than 979px)", "js_composer") => 'ipad_full_width'),
				"group" => __('Responsive options', 'js_composer')
			),		
			array(
				"type" => 'checkbox',
				"heading" => __("Hide this row on screen sizes:", "js_composer"),
				"param_name" => "row_show_on",
				"value" => Array(
					"<strong>Desktop</strong> (on screen sizes larger than 1025px)<br/><br/>" => 'hide_on_normal_screen', 
					"<strong>Tablet Landscape</strong> (on screen sizes from 980px - 1024px)<br/><br/>" => 'hide_tablet_landscape', 
					"<strong>Tablet Portrait</strong> (on screen sizes from 768px - 979px)<br/><br/>" => 'hide_tablet_portrait', 
					"<strong>Mobile Landscape</strong> (on screen sizes from 480px - 767px)<br/><br/>" => 'hide_mobile_landscape', 
					"<strong>Mobile Portrait</strong> (on screen sizes smaller than 479px)" => 'hide_mobile_portrait'
				),
				"group" => __('Responsive options', 'js_composer')
			)
		),
		"js_view" => 'VcRowView'
	) );


	// Buttons
	vc_map( array(
		"name" => __("Styled Button", "js_composer"),
		"base" => "vc_button",
		"icon" => "icon-wpb-ui-button",
		"category" => __('Content', 'js_composer'),
		"description" => __('Eye catching button', 'js_composer'),
		"params" => array(
			array(
				"type" => "vc_link",
				"heading" => __("URL (Link)", "js_composer"),
				"param_name" => "link",
			),
			array(
				"type" => "textfield",
				"heading" => __("Text on the button", "js_composer"),
				"holder" => "button",
				"class" => "wpb_button",
				"param_name" => "title",
				"value" => __("Text on the button", "js_composer"),
			),
			array(
				"type" => "dropdown",
				"heading" => __("Size", "js_composer"),
				"param_name" => "size",
				"value" => array(__("Regular size", "js_composer") => "wpb_regularsize", __("Medium", "js_composer") => "btn-medium", __("Large", "js_composer") => "btn-large"),
			),
			array(
				"type" => "dropdown",
				"heading" => __("Color", "js_composer"),
				"param_name" => "color",
				"value" => array(__("Theme accent color", "js_composer") => "btn_themecolor", __("White", "js_composer") => "btn_white", __("Grey", "js_composer") => "btn_grey", __("Blue", "js_composer") => "btn_blue", __("Turquoise", "js_composer") => "btn_turquoise", __("Green", "js_composer") => "btn_green", __("Orange", "js_composer") => "btn_orange", __("Red", "js_composer") => "btn_red", __("Black", "js_composer") => "btn_black"),
				"description" => __("Button color.", "js_composer")
			),
			array(
				"type" => 'checkbox',
				"heading" => __("Minimal button style?", "js_composer"),
				"param_name" => "button_style",
				"description" => __("Contours & text in selected color with transparent background", "js_composer"),
				"value" => Array(__("Enable", "js_composer") => 'minimal_style')
			),
			array(
				"type" => "font_icons",
				"class" => "",
				"heading" => __("Icon", "js_composer"),
				"param_name" => "icon_name",
				"value" => ''
			),
			$add_css_animation,
			$add_css_animation_delay,
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		),
		"js_view" => 'VcButtonView'
	) );


	// Colored box
	vc_map( array(
		"name" => __("Colored box", "js_composer"),
		"base" => "vc_colored_box",
		"icon" => "icon-wpb-colored_box",
		"category" => __('Content', 'js_composer'),
		"description" => __('Colored background box with text', 'js_composer'),
		"params" => array(
			array(
				"type" => "textfield",
				"heading" => __("Box width (optional)", "js_composer"),
				"param_name" => "width",
				"value" => "",
				"description" => __("Default width is 100%. You can use % or px. Example: 550px", "js_composer")
			),
			array(
				"type" => "dropdown",
				"heading" => __("Box align", "js_composer"),
				"param_name" => "align",
				"value" => array(__("Left", "js_composer") => "", __("Right", "js_composer") => "float-right", __("Centred", "js_composer") => "aligncenter"),
				"dependency" => Array('element' => "href", 'not_empty' => true)
			),
			array(
				"type" => "colorpicker",
				"heading" => __("Background color", "js_composer"),
				"param_name" => "bg_color",
				"value" => '',
				"description" => __("Leave empty to use \"Theme accent color\"", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Box paddings", "js_composer"),
				"param_name" => "padding",
				"value" => "45px",
				"description" => __("The padding property can have from one to four values. Example: 25px 50px 75px 90px", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Margin left (optional)", "js_composer"),
				"param_name" => "margin_left",
				"description" => __("The margin-left property sets the left margin of an element. Example: 40px", "js_composer"),
				"dependency" => Array('element' => "align", 'value' => array('float-right',''))
			),		
			array(
				"type" => "textfield",
				"heading" => __("Margin right (optional)", "js_composer"),
				"param_name" => "margin_right",
				"description" => __("The margin-right property sets the right margin of an element. Example: 40px", "js_composer"),
				"dependency" => Array('element' => "align", 'value' => array('float-right',''))
			),
			array(
				"type" => "textarea_html",
				"holder" => "div",
				"heading" => __("Box text", "js_composer"),
				"param_name" => "content",
				"value" => __("<p>Click edit button to change this text. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut elit tellus, luctus nec ullamcorper mattis, pulvinar dapibus leo.</p>", "js_composer")
			),
			$add_css_animation,
			$add_css_animation_delay,
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		),
		"js_view" => 'VcButtonView'
	) );


	// Progress Bar
	vc_map( array(
	  "name" => __("Progress Bar", "js_composer"),
	  "base" => "vc_progress_bar",
	  "icon" => "icon-wpb-graph",
	  "category" => __('Content', 'js_composer'),
	  "description" => __('Animated progress bar', 'js_composer'),
	  "params" => array(
		array(
		  "type" => "textfield",
		  "heading" => __("Widget title", "js_composer"),
		  "param_name" => "title",
		  "description" => __("What text use as a widget title. Leave blank if no title is needed.", "js_composer")
		),
		array(
		  "type" => "exploded_textarea",
		  "heading" => __("Graphic values", "js_composer"),
		  "param_name" => "values",
		  "description" => __('Input graph values here. Divide values with linebreaks (Enter). Example: 90|Development', 'js_composer'),
		  "value" => "90|Development,80|Design,70|Marketing"
		),
		array(
		  "type" => "textfield",
		  "heading" => __("Units", "js_composer"),
		  "param_name" => "units",
		  "description" => __("Enter measurement units (if needed) Eg. %, px, points, etc. Graph value and unit will be appended to the graph title.", "js_composer")
		),
		array(
		  "type" => "dropdown",
		  "heading" => __("Bar color", "js_composer"),
		  "param_name" => "bgcolor",
		  "value" => array(__("Theme accent color", "js_composer") => "bar_themecolor", __("Grey", "js_composer") => "bar_grey", __("Blue", "js_composer") => "bar_blue", __("Turquoise", "js_composer") => "bar_turquoise", __("Green", "js_composer") => "bar_green", __("Orange", "js_composer") => "bar_orange", __("Red", "js_composer") => "bar_red", __("Black", "js_composer") => "bar_black", __("Custom Color", "js_composer") => "custom"),
		  "description" => __("Select bar background color.", "js_composer"),
		  "admin_label" => true
		),
		array(
		  "type" => "colorpicker",
		  "heading" => __("Bar custom color", "js_composer"),
		  "param_name" => "custombgcolor",
		  "description" => __("Select custom background color for bars.", "js_composer"),
		  "dependency" => Array('element' => "bgcolor", 'value' => array('custom'))
		),
		array(
		  "type" => "checkbox",
		  "heading" => __("Options", "js_composer"),
		  "param_name" => "options",
		  "value" => array(__("Add Stripes?", "js_composer") => "striped", __("Add animation? Will be visible with striped bars.", "js_composer") => "animated")
		),
		array(
		  "type" => "textfield",
		  "heading" => __("Extra class name", "js_composer"),
		  "param_name" => "el_class",
		  "description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
		)
	  )
	) );


	// Heading
	vc_map( array(
		"name" => __("Heading", 'vc_extend'),
		"base" => "vc_heading",
		"icon" => "icon-wpb-vc_heading",
		"category" => __('Content', 'js_composer'),
		"description" => __('Eye catching headings', 'js_composer'),
		"params" => array(
			array(
				"type" => "textfield",
				"heading" => __("Title", "js_composer"),
				"param_name" => "title",
				"value" => "This is title",
				"holder" => "div"
			),		
			array(
				"type" => "textfield",
				"heading" => __("Sub-title", "js_composer"),
				"param_name" => "subtitle",
				"holder" => "div",
				"value" => "",
				"description" => __("Subtitle will be positioned under main title", "js_composer")
			),
			array(
				"type" => "colorpicker",
				"heading" => __("Text color", "js_composer"),
				"param_name" => "color",
				"value" => '#444444',
				"description" => __("", "js_composer")
			),
			array(
				"type" => "dropdown",
				"heading" => __("Text align", "js_composer"),
				"param_name" => "position",
				"value" => array(__("Center", "js_composer") => "center", __("Left", "js_composer") => "left", __("Right", "js_composer") => "right")
			),
			$add_css_animation,
			$add_css_animation_delay,
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		),
		"js_view" => "VcHeadingView"
	) );


	// Icons
	vc_map( array(
		"name" => __("Icons", 'vc_extend'),
		"base" => "vc_icon",
		"icon" => "icon-wpb-vc_icons",
		"category" => __('Content', 'js_composer'),
		"description" => __('Scalable vector icons', 'js_composer'),
		"admin_enqueue_js" => array( MNKY_PLUGIN_URL . 'assets/js/extend-composer-custom-views.js' ),
		"admin_enqueue_css" => array( MNKY_PLUGIN_URL . 'assets/css/extend_js_composer.css', MNKY_PLUGIN_URL . 'assets/css/font-awesome.css'),
		"params" => array(
			array(
				"type" => "font_icons",
				"class" => "",
				"heading" => __("Icon", "js_composer"),
				"param_name" => "name",
				"holder" => "div",
				"value" => "fa-check"
			),
			array(
				"type" => "textfield",
				"heading" => __("Icon size", "js_composer"),
				"param_name" => "icon_size",
				"value" => "28px",
				"description" => __("", "js_composer")
			),
			array(
				"type" => "colorpicker",
				"heading" => __("Icon color", "js_composer"),
				"param_name" => "icon_color",
				"value" => '#444444',
				"description" => __("", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Padding left", "js_composer"),
				"param_name" => "padding_left",
				"value" => "0px",
				"description" => __("The padding-left property sets the left padding (space) of an element.", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Padding right", "js_composer"),
				"param_name" => "padding_right",
				"value" => "0px",
				"description" => __("The padding-right property sets the right padding (space) of an element.", "js_composer")
			),	
			array(
				"type" => "vc_link",
				"heading" => __("URL (Link)", "js_composer"),
				"param_name" => "link",
			),
			array(
				"type" => "dropdown",
				"heading" => __("Hover effect", "js_composer"),
				"param_name" => "hover_effect",
				"value" => array(__("None", "js_composer") => "", __("Fade out", "js_composer") => "fade_out", __("Change color", "js_composer") => "change_color", __("Bounce", "js_composer") => "bounce", __("Shrink", "js_composer") => "shrink")
			),
			array(
				"type" => "colorpicker",
				"heading" => __("Hover color", "js_composer"),
				"param_name" => "hover_color",
				"description" => __("Leave empty to use \"Theme accent color\"", "js_composer"),
				"dependency" => Array('element' => "hover_effect", 'value' => array('change_color'))
			),
			$add_css_animation,
			$add_css_animation_delay,		
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		),
		"js_view" => "VcIconView"
	) );


	// Team
	vc_map( array(
		"name" => __("Team", 'vc_extend'),
		"base" => "vc_team",
		"icon" => "icon-wpb-vc_team",
		"wrapper_class" => "clearfix",
		"category" => __('Content', 'js_composer'),
		"description" => __('Staff members', 'js_composer'),
		"params" => array(
			array(
				"type" => "attach_image",
				"heading" => __("Member image", "js_composer"),
				"param_name" => "img_url",
				"value" => "",
				"holder" => "img", 
				"description" => __("Recommended min. width: 540px", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Name", "js_composer"),
				"param_name" => "name",
				"value" => "John Doe",
				"holder" => "div",
				"description" => __("", "js_composer")
			),		
			array(
				"type" => "textfield",
				"heading" => __("Position", "js_composer"),
				"param_name" => "position",
				"value" => "designer",
				"holder" => "i",
				"description" => __("e.g. \"Senior Designer\"", "js_composer")
			),
			array(
				"type" => "textarea",
				"heading" => __("Hover text", "js_composer"),
				"param_name" => "hover_txt",
				"value" => "",
				"description" => __("", "js_composer")
			),		
			array(
				"type" => "textarea",
				"heading" => __("Aditional info (optional)", "js_composer"),
				"param_name" => "content",
				"value" => "",
				"description" => __("", "js_composer")
			),
			array(
				"type" => "colorpicker",
				"heading" => __("Color scheme", "js_composer"),
				"param_name" => "color_scheme",
				"description" => __("Leave empty to use \"Theme accent color\"", "js_composer")
			),
			$add_css_animation,
			$add_css_animation_delay,
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		),
		"js_view" => 'VcTeamView'
	) );


	// Testimonial slider
	vc_map( array(
		"name" => __("Testimonials", 'vc_extend'),
		"base" => "vc_testimonial_slider",
		"icon" => "icon-wpb-vc_quote", 
		"as_parent" => array('only' => 'vc_testimonial'),
		"is_container" => true,
		"show_settings_on_create" => false,
		"category" => __('Content', 'js_composer'),
		"description" => __('Quote slider', 'js_composer'),
		"params" => array(	
			array(
				"type" => "dropdown",
				"heading" => __("Style", "js_composer"),
				"param_name" => "style",
				"value" => array(__("Dark text", "js_composer") => "layout-dark", __("Light text", "js_composer") => "layout-light")
			),
			array(
				"type" => "dropdown",
				"heading" => __("Animation", "js_composer"),
				"param_name" => "animation",
				"value" => array(__("Slide", "js_composer") => "slide", __("Fade", "js_composer") => "fade")
			),
			array(
				"type" => "textfield",
				"heading" => __("Slide show speed", "js_composer"),
				"param_name" => "slide_speed",
				"value" => "5",
				"description" => __("Set the speed of the slideshow cycling, in seconds", "js_composer")
			),		
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		),
		"custom_markup" => '
			<h4>Testimonials/Quotes</h4>
			<div class="wpb_tetimonial_holder wpb_holder clearfix vc_container_for_children">
			%content%
			</div>
			<div class="tab_controls">
			<button class="add_testimonial" title="'.__("Add testimonial", "js_composer").'">'.__("Add testimonial", "js_composer").'</button>
			</div>
		',
	  'default_content' => '
	  [vc_testimonial name="John Doe" position="Designer"]I am tetimonial text. Click edit button to change this text.[/vc_testimonial]
	  [vc_testimonial name="Nathan Benson" position="Developer"]I am tetimonial text 2. Click edit button to change this text.[/vc_testimonial]
	  ',
	  "js_view" => 'VcTestimonialSliderView'
	  
	) );


	// Testimonial
	vc_map( array(
		"name" => __("Testimonial", 'vc_extend'),
		"base" => "vc_testimonial",
		"is_container" => true,
		"icon" => "icon-wpb-vc_quote", 
		"content_element" => false,
		"as_child" => array('only' => 'vc_testimonial_slider'),
		"category" => __('Content', 'js_composer'),
		"params" => array(
			array(
				"type" => "attach_image",
				"heading" => __("Author image", "js_composer"),
				"param_name" => "img_url",
				"description" => __("Recommended dimensions: 540 x 540px", "js_composer")
			),		
			array(
				"type" => "textfield",
				"heading" => __("Author name", "js_composer"),
				"param_name" => "name",
				"value" => "John Doe",
				"holder" => "h3",
				"description" => __("", "js_composer")
			),		
			array(
				"type" => "textfield",
				"heading" => __("Author info", "js_composer"),
				"param_name" => "author_dec",
				"value" => "Designer",
				"description" => __("e.g. \"Senior Designer\" or  \"Happy Customer\"", "js_composer")
			),
			array(
				"type" => "textarea",
				"class" => "quote_text",
				"heading" => __("Testimonial/Quote text", "js_composer"),
				"holder" => "div",
				"param_name" => "content",
				"value" => __("<p>I am tetimonial text. Click edit button to change this text.</p>", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		)
	) );


	// List item
	vc_map( array(
		"name" => __("List Item", 'vc_extend'),
		"base" => "vc_list_item",
		"icon" => "icon-wpb-vc_list", 
		"is_container" => false,
		"description" => __('List with custom icon', 'js_composer'),
		"category" => __('Content', 'js_composer'),
		"params" => array(
			array(
				"type" => "font_icons",
				"class" => "",
				"heading" => __("Icon", "js_composer"),
				"param_name" => "icon_name",
				"holder" => "div",
				"value" => "fa-check"
			),
			array(
				"type" => "colorpicker",
				"heading" => __("List icon color", "js_composer"),
				"param_name" => "icon_color",
				"description" => __("Leave empty to use \"Theme accent color\"", "js_composer")
			),
			array(
				"type" => "vc_link",
				"heading" => __("URL (Link)", "js_composer"),
				"param_name" => "link",
			),
			array(
				"type" => "textarea",
				"heading" => __("List item text", "js_composer"),
				"holder" => "div",
				"param_name" => "content",
				"value" => __("I am a list item", "js_composer")
			),
			$add_css_animation,
			$add_css_animation_delay,
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)		
		),
		"js_view" => 'VcListItemView'
	) );


	// Service
	vc_map( array(
		"name" => __("Service", 'vc_extend'),
		"base" => "vc_service",
		"icon" => "icon-wpb-vc_service",
		"category" => __('Content', 'js_composer'),
		"description" => __('Service info with custom icon', 'js_composer'),
		"params" => array(
			array(
				"type" => "font_icons",
				"class" => "",
				"heading" => __("Icon", "js_composer"),
				"param_name" => "icon_name",
				"holder" => "div",
				"value" => "fa-check"
			),
			array(
				"type" => "colorpicker",
				"heading" => __("Icon color", "js_composer"),
				"param_name" => "icon_color",
				"description" => __("Leave empty to use \"Theme accent color\"", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Title", "js_composer"),
				"param_name" => "title",
				"holder" => "h4",
				"value" => __("Your service title", "js_composer")
			),
			array(
				"type" => "textarea",
				"heading" => __("Service description", "js_composer"),
				"holder" => "div",
				"param_name" => "content",
				"value" => __("I am service box text. Click edit button to change this text.", "js_composer")
			),
			array(
				"type" => "dropdown",
				"heading" => __("Layout style", "js_composer"),
				"param_name" => "position",
				"value" => array(__("Left", "js_composer") => "", __("Right", "js_composer") => "sb_right", __("Center", "js_composer") => "sb_center")
			),
			array(
				"type" => "vc_link",
				"heading" => __("URL (Link)", "js_composer"),
				"param_name" => "link",
			),
			$add_css_animation,
			$add_css_animation_delay,
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		),
		 "js_view" => 'VcServiceView'

	) );


	// Section nav
	vc_map( array(
		"name" => __("Section menu", 'vc_extend'),
		"base" => "vc_section_menu",
		"icon" => "icon-wpb-vc_section_nav", 
		"as_parent" => array('only' => 'vc_section_menu_item'),
		"is_container" => true,
		"show_settings_on_create" => false,
		"category" => __('Content', 'js_composer'),
		"description" => __('Sticky menu for section navigation ', 'js_composer'),
		"params" => array(	
			array(
				"type" => "colorpicker",
				"heading" => __("Background color", "js_composer"),
				"param_name" => "bg_color",
				"value" => "rgba(30,30,30, 0.65)",
				"group" => __('Default style', 'js_composer'),
			),			
			array(
				"type" => "colorpicker",
				"heading" => __("Link color", "js_composer"),
				"param_name" => "link_color",
				"value" => "#f0f0f0",
				"group" => __('Default style', 'js_composer'),
			),
			array(
				"type" => "colorpicker",
				"heading" => __("Background color when menu is \"sticked\"", "js_composer"),
				"param_name" => "bg_color_sticked",
				"group" => __('Sticked state style', 'js_composer'),
				"value" => "rgba(30,30,30, 0.95)"
			),			
			array(
				"type" => "colorpicker",
				"heading" => __("Link color when menu is \"sticked\"", "js_composer"),
				"param_name" => "link_color_sticked",
				"group" => __('Sticked state style', 'js_composer'),
				"value" => "#fff"
			),			
			array(
				"type" => "colorpicker",
				"heading" => __("\"To top\" button color", "js_composer"),
				"param_name" => "to_top_color",
				"group" => __('Sticked state style', 'js_composer'),
				"value" => "#777777"
			),			
			array(
				"type" => "colorpicker",
				"heading" => __("\"To top\" button hover color", "js_composer"),
				"param_name" => "to_top_color_hover",
				"group" => __('Sticked state style', 'js_composer'),
				"value" => "#aaaaaa"
			),
			array(
				"type" => 'checkbox',
				"heading" => __("Disable \"Back to top\" button", "js_composer"),
				"param_name" => "disable_to_top",
				"value" => Array(__("Yes, please", "js_composer") => 'row-inner-full'),
				"group" => __('Sticked state style', 'js_composer'),
			),
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		),
		"custom_markup" => '
			<h4>Section menu</h4>
			<div class="wpb_list_holder wpb_holder clearfix vc_container_for_children">
			%content%
			</div>
			<div class="tab_controls">
			<button class="add_nav_item" title="'.__("Add navigation link", "js_composer").'">'.__("Add navigation link", "js_composer").'</button>
			</div>
		',
	  "js_view" => 'VcSectionNavView'
	  
	) );


	// Section nav item
	vc_map( array(
		"name" => __("List Item", 'vc_extend'),
		"base" => "vc_section_menu_item",
		"content_element" => false,
		"as_child" => array('only' => 'vc_section_menu'),
		"category" => __('Content', 'js_composer'),
		"params" => array(
			array(
				"type" => "textfield",
				"heading" => __("Link text", "js_composer"),
				"param_name" => "link_text",
				"value" => "Enter link name",
				"holder" => "h4",

				"description" => __("", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Section (Row) ID", "js_composer"),
				"param_name" => "section_id",
				"value" => "enter_id",
				"admin_label" => true,
				"description" => __("Add ID by opening ROW settings and click on \"Section ID\" tab.<br/> You can also use external links adding http:// before address. (e.g. http://themeforest.net)", "js_composer")
			)
		)
	) );


	// Separator (Divider)
	vc_map( array(
	  "name"		=> __("Separator", "js_composer"),
	  "base"		=> "vc_separator",
	  'icon'		=> 'icon-wpb-ui-separator',
	  "category"  => __('Content', 'js_composer'),
	  "description" => __('Horizontal separator line', 'js_composer'),
	  "params" => array(
			array(
				"type" => "dropdown",
				"heading" => __("Type", "js_composer"),
				"param_name" => "style",
				"value" => array(__("Line with icon", "js_composer") => "w_icon", __("Simple line", "js_composer") => "simple", __("Short double line", "js_composer") => "double")
			),
			array(
				"type" => "font_icons",
				"class" => "",
				"heading" => __("Icon", "js_composer"),
				"param_name" => "icon",
				"value" => "",
				"dependency" => Array('element' => "style", 'value' => array('w_icon'))
			),
			array(
				"type" => "dropdown",
				"heading" => __("Icon align", "js_composer"),
				"param_name" => "align",
				"value" => array(__("Center", "js_composer") => "center", __("Left", "js_composer") => "left", __("Right", "js_composer") => "right"),
				"dependency" => Array('element' => "style", 'value' => array('w_icon'))
			),
			array(
				"type" => "colorpicker",
				"heading" => __("Separator line color", "js_composer"),
				"param_name" => "color",
				"value" => '#e2e2e2',
			)	
		)

	) );	
	
	
	// Counter
	vc_map( array(
	  "name"		=> __("Counter", "js_composer"),
	  "base"		=> "vc_counter",
	  'icon'		=> 'icon-wpb-vc_counter',
	  "category"  => __('Content', 'js_composer'),
	  "description" => __('Animated numerical data', 'js_composer'),
	  "params" => array(
			array(
				"type" => "textfield",
				"heading" => __("Value you want to begin at", "js_composer"),
				"param_name" => "from",
				"value" => "0",
				"description" => __("", "js_composer")
			),			
			array(
				"type" => "textfield",
				"heading" => __("Value you want to arrive at", "js_composer"),
				"param_name" => "to",
				"value" => "2000",
				"holder" => "div",
				"description" => __("", "js_composer")
			),			
			array(
				"type" => "textfield",
				"heading" => __("Duration in milliseconds", "js_composer"),
				"param_name" => "speed",
				"value" => "1000",
				"description" => __("", "js_composer")
			),			
			array(
				"type" => "textfield",
				"heading" => __("Interval", "js_composer"),
				"param_name" => "interval",
				"value" => "10",
				"description" => __("How often the element should be updated", "js_composer")
			),	
			array(
				"type" => "textfield",
				"heading" => __("Decimals", "js_composer"),
				"param_name" => "decimals",
				"value" => "0",
				"description" => __("The number of decimal places to show", "js_composer")
			),
			array(
				"type" => "textfield",
				"heading" => __("Extra class name", "js_composer"),
				"param_name" => "el_class",
				"description" => __("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "js_composer")
			)
		)

	) );


	// Empty space (white-space)
	vc_map( array(
		"name" => __("Empty space", 'vc_extend'),
		"base" => "vc_spacer",
		"icon" => "icon-wpb-vc_space",
		"category" => __('Content', 'js_composer'),
		"description" => __('Insert gap between elements', 'js_composer'),
		"params" => array(
			array(
				"type" => "textfield",
				"heading" => __("Space height", "js_composer"),
				"param_name" => "size",
				"value" => "25px",
				"admin_label" => true,
				"description" => __("", "js_composer")
			)
		)
	) );
	
}