<?php
/*
Plugin Name: MNKY | Theme Core Extend
Plugin URI: http://themeforest.net/user/MNKY
Description: Extend Theme and Visual Composer features.
Version: 1.0.0
Author: MNKY
Author URI: http://mnkystudio.com/
License: Envato Marketplaces Split Licence
License URI: Envato Marketplace Item License Certificate 
*/


// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) die;


// Define constantss
define( 'MNKY_PLUGIN_MAIN', __FILE__);
define( 'MNKY_PLUGIN_PATH', plugin_dir_path(__FILE__) );
define( 'MNKY_PLUGIN_URL', plugin_dir_url( __FILE__ ) );

// Add image resizer
require_once ('include/aq_resizer.php');

// Error notice
function mnky_extend_error() {
	$plugin_data = get_plugin_data(__FILE__);
	echo '
	<div class="updated">
		<p>'.sprintf(__('<strong>%s</strong> requires <strong><a href="http://bit.ly/vcomposer" target="_blank">Visual Composer</a></strong> plugin to be installed and activated on your site.', 'aperture'), $plugin_data['Name']).'</p>
	</div>';
}


// Execute after all plugins loaded
add_action( 'plugins_loaded', 'mnky_core_extend' );
function mnky_core_extend() {

	// Display notice if Visual Composer is not installed or activated
	if ( !function_exists( 'vc_map' ) ) {
		add_action('admin_notices', 'mnky_extend_error'); 
		return; 
	}

	
	// Enqueue plugin css and javascript files
	add_action('wp_enqueue_scripts', 'mnky_extend_scripts');
	function mnky_extend_scripts() {
		wp_register_style( 'extend_js_composer_front', MNKY_PLUGIN_URL . 'assets/css/extend_js_composer_front.css', array('js_composer_front') );
		wp_register_style( 'font-awesome', MNKY_PLUGIN_URL . 'assets/css/font-awesome.css', false, '', 'all' );

		wp_enqueue_style( 'extend_js_composer_front' );
		wp_enqueue_style( 'font-awesome' );
	}

	// VC set template dir
	$dir = MNKY_PLUGIN_PATH . '/include/templates/shortcodes/';
	vc_set_template_dir($dir);

	// Disable VC design options
	add_action( 'init', 'remove_design_options' );
	function remove_design_options() {
		vc_set_as_theme($notifier = false);
	}
	
	// Disable VC front-end editor
	vc_disable_frontend();
	
	// Remove VC elements
	vc_remove_element('vc_text_separator');
	vc_remove_element('vc_gallery');
	vc_remove_element('vc_posts_slider');
	vc_remove_element('vc_widget_sidebar');
	vc_remove_element('vc_wp_search');
	vc_remove_element('vc_wp_meta');
	vc_remove_element('vc_wp_recentcomments');
	vc_remove_element('vc_wp_calendar');
	vc_remove_element('vc_wp_pages');
	vc_remove_element('vc_wp_tagcloud');
	vc_remove_element('vc_wp_custommenu');
	vc_remove_element('vc_wp_text');
	vc_remove_element('vc_wp_posts');
	vc_remove_element('vc_wp_links');
	vc_remove_element('vc_wp_categories');
	vc_remove_element('vc_wp_archives');
	vc_remove_element('vc_wp_rss');
	vc_remove_element('vc_pie');
	vc_remove_element('vc_carousel');
	vc_remove_element('vc_images_carousel');
	vc_remove_element('vc_posts_grid');
	vc_remove_element('vc_cta_button');
	vc_remove_element('vc_cta_button2');
	
	// Add params
	require_once ('include/params/params.php');
	
	// Add shortcodes
	require_once ('include/classes/heading.php');	
	require_once ('include/classes/team.php');
	require_once ('include/classes/testimonials.php');
	require_once ('include/classes/spacer.php');
	require_once ('include/classes/icon.php');
	require_once ('include/classes/list.php');
	require_once ('include/classes/section-menu.php');
	require_once ('include/classes/service.php');
	require_once ('include/classes/colored-box.php');	
	require_once ('include/classes/counter.php');	
	
	// Extend VC map
	require_once ('config/map.php');

}